<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="羊只耳号" prop="sheepId">
        <el-input
          v-model="queryParams.sheepId"
          placeholder="请输入羊只耳号"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="治疗日期" style="width: 308px">
        <el-date-picker
          v-model="daterangeDatetime"
          value-format="YYYY-MM-DD"
          type="daterange"
          range-separator="-"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
        ></el-date-picker>
      </el-form-item>
      <el-form-item label="兽医" prop="veterinary">
        <el-input
          v-model="queryParams.veterinary"
          placeholder="请输入兽医"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['treatment:treatment:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['treatment:treatment:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['treatment:treatment:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['treatment:treatment:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="treatmentList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="羊只耳号" align="center" prop="sheepId" />
      <el-table-column label="品种" align="center" prop="variety" />
      <el-table-column label="羊只类别" align="center" prop="sheepType" />
      <el-table-column label="月龄" align="center" prop="monthAge" />
      <el-table-column label="性别" align="center" prop="gender" />
      <el-table-column label="胎次" align="center" prop="parity" />
      <el-table-column label="繁殖状态" align="center" prop="breed" />
      <el-table-column label="泌乳天数" align="center" prop="lactDay" />
      <el-table-column label="怀孕天数" align="center" prop="gestDay" />
      <el-table-column label="治疗日期" align="center" prop="datetime" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.datetime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="疾病类型" align="center" prop="diseaseId" />
      <el-table-column label="父疾病" align="center" prop="diseasePid" />
      <el-table-column label="兽医" align="center" prop="veterinary" />
      <el-table-column label="备注" align="center" prop="comment" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['treatment:treatment:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['treatment:treatment:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改治疗记录对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="treatmentRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="羊只耳号" prop="sheepId">
          <el-input v-model="form.sheepId" placeholder="请输入羊只耳号" />
        </el-form-item>
        <el-form-item label="品种" prop="variety">
          <el-input v-model="form.variety" placeholder="请输入品种" />
        </el-form-item>
        <el-form-item label="月龄" prop="monthAge">
          <el-input v-model="form.monthAge" placeholder="请输入月龄" />
        </el-form-item>
        <el-form-item label="性别" prop="gender">
          <el-input v-model="form.gender" placeholder="请输入性别" />
        </el-form-item>
        <el-form-item label="胎次" prop="parity">
          <el-input v-model="form.parity" placeholder="请输入胎次" />
        </el-form-item>
        <el-form-item label="繁殖状态" prop="breed">
          <el-input v-model="form.breed" placeholder="请输入繁殖状态" />
        </el-form-item>
        <el-form-item label="泌乳天数" prop="lactDay">
          <el-input v-model="form.lactDay" placeholder="请输入泌乳天数" />
        </el-form-item>
        <el-form-item label="怀孕天数" prop="gestDay">
          <el-input v-model="form.gestDay" placeholder="请输入怀孕天数" />
        </el-form-item>
        <el-form-item label="治疗日期" prop="datetime">
          <el-date-picker clearable
            v-model="form.datetime"
            type="date"
            value-format="YYYY-MM-DD"
            placeholder="请选择治疗日期">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="父疾病" prop="diseasePid">
          <el-input v-model="form.diseasePid" placeholder="请输入父疾病" />
        </el-form-item>
        <el-form-item label="兽医" prop="veterinary">
          <el-input v-model="form.veterinary" placeholder="请输入兽医" />
        </el-form-item>
        <el-form-item label="药品使用记录id" prop="usageId">
          <el-input v-model="form.usageId" placeholder="请输入药品使用记录id" />
        </el-form-item>
        <el-form-item label="备注" prop="comment">
          <el-input v-model="form.comment" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Treatment">
import { listTreatment, getTreatment, delTreatment, addTreatment, updateTreatment } from "@/api/biosafety/treatment"

const { proxy } = getCurrentInstance()

const treatmentList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref("")
const daterangeDatetime = ref([])

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    sheepId: null,
    datetime: null,
    diseaseId: null,
    veterinary: null,
  },
  rules: {
  }
})

const { queryParams, form, rules } = toRefs(data)

/** 查询治疗记录列表 */
function getList() {
  loading.value = true
  queryParams.value.params = {}
  if (null != daterangeDatetime && '' != daterangeDatetime) {
    queryParams.value.params["beginDatetime"] = daterangeDatetime.value[0]
    queryParams.value.params["endDatetime"] = daterangeDatetime.value[1]
  }
  listTreatment(queryParams.value).then(response => {
    treatmentList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  reset()
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    diagId: null,
    sheepId: null,
    variety: null,
    sheepType: null,
    monthAge: null,
    gender: null,
    parity: null,
    breed: null,
    lactDay: null,
    gestDay: null,
    datetime: null,
    diseaseId: null,
    diseasePid: null,
    veterinary: null,
    usageId: null,
    comment: null,
    updateBy: null,
    updateTime: null,
    createBy: null,
    createTime: null
  }
  proxy.resetForm("treatmentRef")
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  daterangeDatetime.value = []
  proxy.resetForm("queryRef")
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  title.value = "添加治疗记录"
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _id = row.id || ids.value
  getTreatment(_id).then(response => {
    form.value = response.data
    open.value = true
    title.value = "修改治疗记录"
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["treatmentRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateTreatment(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        addTreatment(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value
  proxy.$modal.confirm('是否确认删除治疗记录编号为"' + _ids + '"的数据项？').then(function() {
    return delTreatment(_ids)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => {})
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('treatment/treatment/export', {
    ...queryParams.value
  }, `treatment_${new Date().getTime()}.xlsx`)
}

getList()
</script>
